/**
 *
 * Copyright (C) 2013, 2014 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef TREE_H
#define TREE_H
#include <algorithm>    // std::sort
#include <vector> 
#include "Geometry.h"
#include "Transform.h"

#include "Triangle.h"


class BSP{
 protected:
  int axe;
  int depth;
  gk::BBox bbox;
  std::vector<gk::Triangle> triangles;
  BSP* left;
  BSP* right;

 public:
 BSP():depth(0),left(NULL),right(NULL){}
 BSP(std::vector<gk::Triangle> triangles,int depth):depth(depth),triangles(triangles),left(NULL),right(NULL){
    build();
  }
  ~BSP(){}

  void build();
  bool intersect(const gk::Ray& ray, gk::Hit& hit);
  bool intersectedObject(const gk::Ray& ray, gk::Hit& hit);
};

#endif
